# ‹› `` `markdown.blockparser`

The block parser handles basic parsing of Markdown blocks. It doesn’t concern itself with inline elements such as `**bold**` or `*italics*`, but rather just catches blocks, lists, quotes, etc.

The `BlockParser` is made up of a bunch of `BlockProcessors`, each handling a different type of block. Extensions may add/replace/remove `BlockProcessors` as they need to alter how Markdown blocks are parsed.

Classes:

- `State` –

  Track the current and nested state of the parser.

- `BlockParser` –

  Parse Markdown blocks into an `ElementTree` object.

## ‹› `` `markdown.blockparser.State`

Bases: `list`

Track the current and nested state of the parser.

This utility class is used to track the state of the `BlockParser` and support multiple levels if nesting. It’s just a simple API wrapped around a list. Each time a state is set, that state is appended to the end of the list. Each time a state is reset, that state is removed from the end of the list.

Therefore, each time a state is set for a nested block, that state must be reset when we back out of that level of nesting or the state could be corrupted.

While all the methods of a list object are available, only the three defined below need be used.

Methods:

- `set` –

  Set a new state.

- `reset` –

  Step back one step in nested state.

- `isstate` –

  Test that top (current) level is of given state.

### ‹› `` `markdown.blockparser.State.set(state: Any)`

Set a new state.

### ‹› `` `markdown.blockparser.State.reset() -> None`

Step back one step in nested state.

### ‹› `` `markdown.blockparser.State.isstate(state: Any) -> bool`

Test that top (current) level is of given state.

## ‹› `` `markdown.blockparser.BlockParser(md: Markdown)`

Parse Markdown blocks into an `ElementTree` object.

A wrapper class that stitches the various `BlockProcessors` together, looping through them and creating an `ElementTree` object.

Parameters:

- `md` (`Markdown`) –

  A Markdown instance.

Attributes:

- `BlockParser.md` (`Markdown`) –

  A Markdown instance.

- `BlockParser.state` (`State`) –

  Tracks the nesting level of current location in document being parsed.

- `BlockParser.blockprocessors` (`Registry`) –

  A collection of `blockprocessors`.

Methods:

- `parseDocument` –

  Parse a Markdown document into an `ElementTree`.

- `parseChunk` –

  Parse a chunk of Markdown text and attach to given `etree` node.

- `parseBlocks` –

  Process blocks of Markdown text and attach to given `etree` node.

### ‹› `` `markdown.blockparser.BlockParser.parseDocument(lines: Iterable[str]) -> etree.ElementTree`

Parse a Markdown document into an `ElementTree`.

Given a list of lines, an `ElementTree` object (not just a parent `Element`) is created and the root element is passed to the parser as the parent. The `ElementTree` object is returned.

This should only be called on an entire document, not pieces.

Parameters:

- `lines` (`Iterable[str]`) –

  A list of lines (strings).

Returns:

- `ElementTree` –

  An element tree.

### ‹› `` `markdown.blockparser.BlockParser.parseChunk(parent: etree.Element, text: str) -> None`

Parse a chunk of Markdown text and attach to given `etree` node.

While the `text` argument is generally assumed to contain multiple blocks which will be split on blank lines, it could contain only one block. Generally, this method would be called by extensions when block parsing is required.

The `parent` `etree` Element passed in is altered in place. Nothing is returned.

Parameters:

- `parent` (`Element`) –

  The parent element.

- `text` (`str`) –

  The text to parse.

### ‹› `` `markdown.blockparser.BlockParser.parseBlocks(parent: etree.Element, blocks: list[str]) -> None`

Process blocks of Markdown text and attach to given `etree` node.

Given a list of `blocks`, each `blockprocessor` is stepped through until there are no blocks left. While an extension could potentially call this method directly, it’s generally expected to be used internally.

This is a public method as an extension may need to add/alter additional `BlockProcessors` which call this method to recursively parse a nested block.

Parameters:

- `parent` (`Element`) –

  The parent element.

- `blocks` (`list[str]`) –

  The blocks of text to parse.